// JSify the animal file system explorator
function jsifyAnimalFs() {
	var d = document.getElementById('animal_fs');
	if(!d) return;
	
	var items = d.getElementsByTagName('div');
	var o = null;
	for(var i=0; i<items.length; i++) {
		if(!items[i].getAttribute('ref') || !items[i].className.match(/animal_(dir|file)/)) continue;
		
		items[i].container = d;
		
		items[i].open = function() {
			var d = this.container.getElementsByTagName('div');
			var p = this.clearPath();
			p = p.substr(0, p.lastIndexOf('/'));
			if(document.getElementById('editfile_path')) document.getElementById('editfile_path').value = p;
			for(var i=0; i<d.length; i++) {
				if(!d[i].getAttribute('ref') || !d[i].getAttribute('pref') || !d[i].className.match(/animal_(dir|file)/)) continue;
				if(d[i].getAttribute('ref') == this.getAttribute('pref') && d[i].container) {
					d[i].open();
					return;
				}
			}
		};
		
		items[i].clearPath = function() {
			input = this.getAttribute('ref');
			var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
			var output = "";
			var chr1, chr2, chr3 = "";
			var enc1, enc2, enc3, enc4 = "";
			var i = 0;
			
			input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
			
			do {
				enc1 = keyStr.indexOf(input.charAt(i++));
				enc2 = keyStr.indexOf(input.charAt(i++));
				enc3 = keyStr.indexOf(input.charAt(i++));
				enc4 = keyStr.indexOf(input.charAt(i++));
				chr1 = (enc1 << 2) | (enc2 >> 4);
				chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
				chr3 = ((enc3 & 3) << 6) | enc4;
				output = output + String.fromCharCode(chr1);
				if(enc3 != 64) output += String.fromCharCode(chr2);
				if(enc4 != 64) output += String.fromCharCode(chr3);
				chr1 = chr2 = chr3 = "";
				enc1 = enc2 = enc3 = enc4 = "";
			} while (i < input.length);
			return unescape(output);
		};
		
		if(d.getAttribute('openned') == items[i].getAttribute('ref')) o = items[i];
		
		if(!items[i].className.match(/animal_dir/)) continue;
		
		items[i].openned = true;
		items[i].toggle = function() {
			if(this.openned) {
				this.close();
			}else{
				if(document.getElementById('editfile_path')) document.getElementById('editfile_path').value = this.clearPath();
				this.open();
			}
		};
		
		items[i].onclick = items[i].toggle;
		
		items[i].open = function() {
			if(this.openned) return;
			this.openned = true;
			var d = this.container.getElementsByTagName('div');
			for(var i=0; i<d.length; i++) {
				if(!d[i].getAttribute('ref') || !d[i].className.match(/animal_(dir|file)/)) continue;
				if(d[i].getAttribute('ref') == this.getAttribute('pref') && d[i].container) d[i].open();
				if(d[i].getAttribute('pref') == this.getAttribute('ref')) d[i].style.display = 'block';
			}
		};
		
		items[i].close = function() {
			if(!this.openned) return;
			this.openned = false;
			var d = this.container.getElementsByTagName('div');
			for(var i=0; i<d.length; i++) {
				if(!d[i].getAttribute('ref') || !d[i].getAttribute('pref') || !d[i].className.match(/animal_(dir|file)/)) continue;
				if(d[i].getAttribute('pref') == this.getAttribute('ref')) {
					if(d[i].className.match(/animal_dir/)) d[i].close();
					d[i].style.display = 'none';
				}
			}
		};
	}
	
	for(var i=0; i<items.length; i++) {
		if(!items[i].getAttribute('ref') || !items[i].className.match(/animal_dir/)) continue;
		if(items[i].getAttribute('pref') == '') items[i].close();
	}
	
	if(o) {
		var p = o.clearPath();
		if(!o.className.match(/animal_dir/)) p = p.substr(0, p.lastIndexOf('/'));
		if(document.getElementById('editfile_path')) document.getElementById('editfile_path').value = p;
		o.open();
	}
}

// Hud height trick
function adaptAnimalHud() {
	var d = document.getElementsByTagName('div');
	for(var i=0; i<d.length; i++) {
		if(!d[i].className.match(/animal_hud/)) continue;
		var ph = d[i].parentNode.offsetHeight;
		d[i].style.height = ph + 'px';
	}
}

// Register functions
addInitEvent(jsifyAnimalFs);
addInitEvent(adaptAnimalHud);
