
var imageflow_plugin = function(root) {
	
	var _self = this;
	
	this.root = root;
	
	this.widthfactor = 0.51;
	this.reflectionHeight = 0.5;
	this.bottomLine = this.root.offsetWidth * 0.33; // Or false 

	this.imagesroot = null;
	this.checkedImages = new Array();
	this.imageflowDone = false;

	this.current = 0;
	this.xstep = 150; // pixel to move;
	this.xstepWidthScaleFactor = 0.80; // scale the width of the images  
	this.xstepHeightScaleFactor = 0.60; // scale the height of the images  
	this.focusedElememtsPerSide = 5;

	this.maxheight = this.root.offsetWidth * this.widthfactor;
	this.timeOutAction = null;
	this.whereToMoveQueue = new Array();

	this.images = null;
	this.caption = null;

	// Loader
	this.loadingbar = null;
	this.loadingbartext = null;
	this.loadingbarloader = null;
	
	// Scroller
	this.scrollbarwidth = this.root.offsetWidth * 0.6;
	this.scrollbarSliderOffsetLeft = 38; 
	this.scrollbarSliderOffsetRight = 54;
	this.scrollleft = null;
	this.scrollright = null;
	this.scroller = null;
	
	this.dragStartPosition = false;
	this.scrollerStartDragOffset = false;
	this.scrollerDragOffset = 0;
	this.scrollerIsDragging = false;
	this.scrollerDownIntervall = false;
	this.mouseDownByDrag = false;
	
	this.intermediateImageSrc = DOKU_BASE + 'lib/plugins/imageflow/images/intermediate.png';
	
	this.debug = false;
	
	this.buildBasicStructure = function() {
		
		if ( this.loadingbar !== null || this.images !== null ) { return false; }
		
		var newRoot = document.createElement('div');
		newRoot.className = 'imageflow_root';
		this.root.appendChild(newRoot);
		
		// Start Build Loader
		this.loadingbar = document.createElement('div');
		this.loadingbar.className = 'imageflow_loadingbar_container';
		this.loadingbar.style.top = (this.root.offsetHeight/2 -8) + 'px';
		this.loadingbar.style.left = (this.root.offsetWidth/2 -100) + 'px';
		
		this.loadingbarloader = document.createElement('div');
		this.loadingbarloader.className = 'imageflow_loader';
		
		this.loadingbartext = document.createElement('p');
		this.loadingbartext.appendChild(document.createTextNode('Loading in progress.'));
		
		this.loadingbar.appendChild(this.loadingbarloader);
		this.loadingbar.appendChild(this.loadingbartext);

		newRoot.appendChild(this.loadingbar);
		// End Build Loader

		// Start Build Images Container
		this.images = document.createElement('div');
		this.images.className = 'imageflow_images';
		this.images.style.height = this.root.offsetWidth * 0.338 + 'px';

		newRoot.appendChild(this.images);
		// End Build Images Container

		var splitter = document.createElement('div');
		splitter.className = 'imageflow_no_scroller';
		
		newRoot.appendChild(splitter);
		
		// Start Build Scroller Container
		var scrollbar = document.createElement('div');
		scrollbar.className = 'imageflow_scrollbar';
		scrollbar.style.marginTop = this.root.offsetWidth * 0.02 + 40 + 'px';
		scrollbar.style.width = this.scrollbarwidth + 'px';
		scrollbar.style.left = ((this.root.offsetWidth - (this.scrollbarwidth + this.scrollbarSliderOffsetLeft + this.scrollbarSliderOffsetRight)) / 2) + 'px';

		/* Set slider attributes */
		this.scrollleft = document.createElement('div');
		this.scrollleft.className = 'imageflow_slider_cap_left';
		scrollbar.appendChild(this.scrollleft);

		this.scroller = document.createElement('div');
		this.scroller.className = 'imageflow_slider';
		scrollbar.appendChild(this.scroller);

		this.scrollright = document.createElement('div');
		this.scrollright.className = 'imageflow_slider_cap_right';
		scrollbar.appendChild(this.scrollright);
		
		// AttachEvents
		addEvent(this.scroller, 'mousedown', function(e) { _self.dragStart(e); } );

		addEvent(this.scrollleft, 'mousedown', function(e) { _self.stopEvent(e); _self.scrollerSideDown(-1); } );
		addEvent(this.scrollright, 'mousedown', function(e) { _self.stopEvent(e); _self.scrollerSideDown(1); } );

		addEvent(document, 'mouseup', function(e) { _self.stopEvent(e); _self.scrollerSideUp(); } );
		addEvent(scrollbar, 'click', function(e) { _self.scrollerClick(e); } );
		
		newRoot.appendChild(scrollbar);
		// End Build Scroller Container
		
		// Start Build Caption Container
		this.caption = document.createElement('div');
		this.caption.className = 'imageflow_caption';
		this.caption.style.width = (this.root.offsetWidth * 0.5) + 'px';
		this.caption.style.left = (this.root.offsetWidth * 0.25) + 'px';
		this.caption.style.marginTop = this.root.offsetWidth * 0.02 + 'px';

		newRoot.appendChild(this.caption);
		// End Build Caption Container
		
		if ( !this.debug ) { return; } 
		// Add Debug
		this.debug = document.createElement('div');
		this.debug.className = 'debug';
		
		this.debug.appendChild(document.createTextNode('Debug is enabled.'));
		
		newRoot.appendChild(this.debug);
	};
	
	this.stopEvent = function(event) {
		event = event||window.event;
		
		if (event) {
			event.cancelBubble = true;
			event.returnValue = false;
			if (event.stopPropagation) { event.stopPropagation(); }
			if (event.preventDefault) { event.preventDefault(); }
		}
	};
	
	this.loadImageEvent = function (src, eventFkt) {
		var loadImage = new Image();
		addEvent(loadImage, 'load', eventFkt);
		loadImage.src = src;
	};
	
	// Set Timeout for clusores
	this.timeOut = function(fkt, time) {
		setTimeout(function(e) { _self[fkt](e, this); }, time);
	};
	
	this.init = function() {
		
		this.root.className += " scripting_active";
		this.root.innerHTML = "";
		this.root.style.height = (this.maxheight + 20) + 'px';
		this.buildBasicStructure();
		
		// Loader Image Cascade
		// Prepare Loader images - they have to be shown very first.
		var loadImage = new Image();
		addEvent(loadImage, 'load', function() {

			_self.loadingbar.style.display = 'block'; // Show loader Bar
			var loadImage = new Image();
			addEvent(loadImage, 'load', function() {
				_self.timeOut('initImages', 500);
			});
			
			loadImage.src = DOKU_BASE + 'lib/plugins/imageflow/images/loader_bg.gif';
		});
		
		loadImage.src = DOKU_BASE + 'lib/plugins/imageflow/images/loader.gif';
		
		var intermediate = new Image();
		intermediate.src = this.intermediateImageSrc;

	};
	
	this.initImages = function () {
		
		try {
			// get images from JSINFO var
			this.imagesroot = JSINFO['relation']['imageflow'][this.root.id];

			for ( var i in this.imagesroot ) {
				
				var imgData = this.imagesroot[i];
				if ( typeof imgData == 'undefined' ) { continue; }
				
				var imgRep = new imageRepresentation();
				imgRep.init(imgData);
				
				this.checkedImages.push(imgRep);
			}
			
			this.timeOut('checkForImagesReady', 50);
		} catch(e) {}
	};
	
	/*
	 * END OF ALL INIT THINGS
	 */
	
	
	/*
	 * Represents an image with special functions inside
	 */
	var imageRepresentation = function() {
		
		var __self = this;
		
		this.imgData = null;
		this.image = null;
		this.id = null;
		
		this.counter = 300;
		this.isFinished = false;
		
		this.x_pos = 0;
		this.width = 0;
		this.height = 0;
		this.pc = 0;
		
		this.isImageOk = function(img) {
			
			if ( !img ) { img = this.image };
			if (!img.complete) { return false; }
			if (typeof img.naturalWidth != "undefined" && img.naturalWidth == 0) { return false; }

			// No Way to determine
			return true;
		};
		
		this.intermediateFinish = function() {
			
			this.counter = 10;
			this.imgData.intermediateImage = this.image;
			this.image = new Image();

			this.imgData.intermediateImage.onload = function(e) {

				// reset the image
				__self.image.parentNode.replaceChild(__self.imgData.intermediateImage, __self.image);
				__self.image = __self.imgData.intermediateImage;
				__self.finish();
				
				_self.moveTo(_self.current); // Force repaint
			};
			
			addEvent(this.image, 'load', function(e) { __self.finish(); });
			this.image.src = _self.intermediateImageSrc;
		};
		
		this.finish = function() {
			
			this.counter = 0; 
			this.width = this.image.width;
			this.height = this.image.height; // - ( this.image.height * this.reflectionHeight ); // Height w/o reflection

			/* Check source image format. Get image height minus reflection height! */
			this.pc = _self.xstep * (((this.width + 1) > (this.height / (_self.reflectionHeight + 1))) ? _self.xstepWidthScaleFactor : _self.xstepHeightScaleFactor);
		};
		
		this.checkFinished = function() {
			var isOK = this.isImageOk();
			if ( !isOK && this.counter > 0 ) {
				this.counter--;
				return false;
			} else if ( !isOK && this.counter == 0) {
				this.intermediateFinish();
			}
			
			this.isFinished = true;
			this.finish();
			return true;
		};
		
		this.init = function(imgData) {
			
			this.imgData = imgData;
			this.imgData.isImage = true;
			
			this.image = new Image();
			var src = this.imgData.src;
			if ( imgData.params ) {
				for ( var key in imgData.params) {
					src += (src.indexOf('?') > 0 ? '&' : '?') + escape(key) + "=" + escape(imgData.params[key]);
				}
			}
			
			this.image.src = src;
			this.image.id = this.imgData.id;
			this.id = this.imgData.id;
			this.image.style.display = 'none';

			addEvent(this.image, 'load', function() { __self.finish(); });
		}
	};	
	
	this.loadingStatus = function() {
		
		var completed = 0; var total = 0;
		
		for ( var img in this.checkedImages ) {
			if ( this.checkedImages[img].isFinished || this.checkedImages[img].checkFinished() ) { completed++; }
			total ++;
		}

		var finished = Math.round((completed/total)*100);
		if ( finished >= 100 ) { finished = 100; }
		
		this.loadingbarloader.style.width = finished+'%';
		this.loadingbar.style.display = 'block';

		var loadingTxt = document.createTextNode('Loading Images ' + completed + '/' + total);
		this.loadingbartext.replaceChild(loadingTxt,this.loadingbartext.firstChild);

		return finished;
	};
	
	this.checkForImagesReady = function() {
		
		if ( this.imageflowDone ) { return; }
		if ( this.loadingStatus() < 100 ) {
			this.timeOut('checkForImagesReady', 50);
			return;
		} else {
			this.imageflowDone = true;
		}
		
		this.refreshImageFlow();
		this.addGlobalEvents();
		this.checkForPopUp();
	};
	
	this.addGlobalEvents = function () {
		/** DOMMouseScroll is for mozilla. */
		if (window.addEventListener) {
	        window.addEventListener('DOMMouseScroll', function(e) { _self.globalEvent(e); }, false);
		}
		addEvent(this.root, 'mousewheel', function(e) { _self.globalEvent(e); });
		addEvent(document, 'keydown', function(e) { _self.globalEvent(e); });
		addEvent(this.root, 'mousemove', function(e) { _self.drag(e); } );

		addEvent(document, 'mouseup', function(e) { _self.dragStop(e); } );
		addEvent(this.root, 'selectstart', function (e) { _self.dragStop(e); } );
		
	};
	
	/*
	 * BEGINN OF ALL MOVEMENT THINGS
	 */
	this.refreshImageFlow = function() {
		
		var img = 0;
		for ( img; img < this.checkedImages.length; img++ ) {
			var imageElement = this.checkedImages[img];

			this.images.appendChild(imageElement.image);

			imageElement.image.style.display = 'block';
			imageElement.image.style.cursor = 'pointer';

			imageElement.image.onclick = function(e) { _self.elementClick(e); };
			imageElement.image.ondblclick = function(e) { _self.specialClick(e); };
			
			addEvent(imageElement.image, 'mousedown', function(e) { _self.dragStart(e); } );
		}

		if ( img <= 1 ) {
			var loadingTxt = document.createTextNode('Ups. There are no Images.');
			this.loadingbartext.replaceChild(loadingTxt,this.loadingbartext.firstChild);
			this.loadingbartext.style.color = "#a00";
			
			return;
		}
		
		this.loadingbar.style.display = 'none';
		this.scroller.parentNode.style.visibility = 'visible';
		this.moveTo(this.current, this.current);
		this.glideTo(this.current);
	};
	
	this.moveTo = function(whereToMove, origWhereToMoveIndex) {
		
		//this.current = whereToMove;
		var zIndex = this.checkedImages.length;
		var size = this.root.offsetWidth * 0.5;
		var images_top = 50; // Offset from top
		
		for ( var img in this.checkedImages ) {
			var imageElement = this.checkedImages[img];
			
			// Hide Elements outside of our viewport
			if ( img < this.current - this.focusedElememtsPerSide || img > this.current + this.focusedElememtsPerSide ) {
				imageElement.image.style.display = 'none';
				imageElement.image.style.visiblity = 'hidden';
				continue;
			}
			
			var movement = (img - this.current) * this.xstep;
			var z = Math.sqrt(10000 + movement * movement) + 100;
			var xs = movement / z * size + size;

			/* Still hide images until they are processed, but set display style to block */
			imageElement.image.style.display = 'block';
			
			/* Process new image height and image width */
			var new_img_h = (imageElement.height / imageElement.width * imageElement.pc) / z * size;
			var new_img_w = imageElement.pc / z * size;
			
			if ( new_img_h > this.maxheight ) {
				new_img_h = this.maxheight;
				new_img_w = imageElement.width * new_img_h / imageElement.height;
			}
			
			var new_img_top = ((new_img_h / (this.reflectionHeight + 1)) * this.reflectionHeight);
			if ( this.bottomLine !== false ) { new_img_top += (this.bottomLine - new_img_h); }
			
			imageElement.image.style.left = xs - (imageElement.pc / 2) / z * size + 'px';

			if(new_img_w && new_img_h)
			{ 
				imageElement.image.style.height = new_img_h + 'px'; 
				imageElement.image.style.width = new_img_w + 'px'; 
				imageElement.image.style.top = new_img_top + 'px';
			}
			
			imageElement.image.style.visibility = 'visible';
			
			/* Set image layer through zIndex */
			if ((img - this.current) < 0) {
				zIndex++;
			} else {
				zIndex--;
			}
			
			// register new handles
			if ( img == origWhereToMoveIndex ) {
				zIndex++;

				imageElement.image.onclick = function(e) { _self.specialClick(e); };
			} else {
				imageElement.image.onclick = function(e) { _self.elementClick(e); };
			}
			
			imageElement.image.style.zIndex = zIndex;
		}
		
		this.current = whereToMove;
		
		// Set Caption, though its not performaing best here
		if (this.checkedImages[origWhereToMoveIndex]) { this.buildCaptionForElement(this.checkedImages[origWhereToMoveIndex].imgData); }
		this.setSliderPosition();
	};
	
	this.buildCaptionForElement = function(imgData) {

		// Remove old Caption
		this.caption.innerHTML = "";

		// Create new Caption if title or caption given
		if ( imgData.title ) {
			var title = document.createElement('h3');
			title.appendChild(document.createTextNode(imgData.title));
			this.caption.appendChild(title);
		}
		
		if ( imgData.desc ) {
			var caption = document.createElement('p');
			caption.appendChild(document.createTextNode(imgData.desc));
			this.caption.appendChild(caption);
		}
	};
	
	this.setSliderPosition = function(override) {
		var new_slider_pos = (this.scrollbarwidth * (this.current/(this.checkedImages.length-1)));
		if ( new_slider_pos >= 0 &&  new_slider_pos <= this.scrollbarwidth && ( this.scrollerStartDragOffset === false || override === true ) ) {
			this.scroller.style.marginLeft = new_slider_pos - (this.scroller.offsetWidth / 2) + 'px';
		}
	};
	
	this.glideTo = function(whereToMove) {

		if ( whereToMove < 0 ) { whereToMove = 0; }
		if ( whereToMove >= this.checkedImages.length ) { whereToMove = this.checkedImages.length-1; }
		
		// Animate gliding to new position
		// If current position is not the desired one
		var devident = (this.whereToMoveQueue.length > 1 ? 1 : this.xstep); // check distance
		if ( whereToMove < this.current - 1/devident || whereToMove > this.current + 1/devident ) 
		{
			this.moveTo(this.current + (whereToMove-this.current)/3, whereToMove); // move in three steps
			this.timeOutAction = setTimeout(function(){ _self.glideTo(whereToMove) }, 50);
			return;
		}
		
		this.current = whereToMove;

		if ( this.whereToMoveQueue.length > 1 ) { // Asume, the first entry is the first moving step
			this.timeOutAction = setTimeout(function() {
				_self.glideTo(parseInt(_self.whereToMoveQueue.splice(1,1))); }, 50);
		} else {

			// Display new caption
			this.moveTo(this.current, this.current); // If the above got interrupted, set the new distance

			this.timeOutAction = null; // Reset Timeout
			_self.whereToMoveQueue = new Array();
		}
	};
	
	this.addMoveElementToQueue = function (whereToMove) {
		if ( whereToMove < 0 ) { whereToMove = 0; } // Already the first
		if ( whereToMove >= this.checkedImages.length ) { whereToMove = this.checkedImages.length-1; } // This is already the last

		this.whereToMoveQueue.push(whereToMove);
		this.glideTo(whereToMove);

		return true;
	};
	
	this.handle = function(delta) {

		var whereToMove = this.current;
		if ( this.timeOutAction ) {
			clearTimeout(this.timeOutAction);
			this.timeOutAction = null;
			whereToMove = parseInt(this.whereToMoveQueue[this.whereToMoveQueue.length - 1]);
			this.whereToMoveQueue = new Array();
		}
		
		whereToMove += delta;
		if ( this.addMoveElementToQueue(whereToMove) ) { return whereToMove; }
	};
	
	this.drag = function(e) {
	
		e = e ||window.event;
		if ( !this.dragStartPosition ) { return; } // Dragging not inited

		var direction = this.scrollerIsDragging ? 1 : -1;
		var posx = document.all ? window.event.clientX : e.pageX;
		var move =  direction * (posx - this.dragStartPosition);

		this.stopEvent(e);
		// this.debug.innerHTML = "Draging " + ((e.target) ? e.target : e.srcElement).id;
		
		if ( !this.scrollerIsDragging ) { // Dragging at the image

			// this.debug.innerHTML += " dragging image";
			
			if ( this.scrollerStartDragOffset === false || isNaN(this.scrollerStartDragOffset.target) || isNaN(this.scrollerStartDragOffset.current) ) {
				this.scrollerStartDragOffset = {};
				this.scrollerStartDragOffset.target = this.getClickImage(e);
				this.scrollerStartDragOffset.current = this.current;
				
				// this.debug.innerHTML += " setting StartDragOffset (" + this.scrollerStartDragOffset.target + " / " + this.scrollerStartDragOffset.current + ")";
			}
			
			var s = this.images.offsetWidth/2;
			var movement = (this.scrollerStartDragOffset.target - this.scrollerStartDragOffset.current) * this.xstep;
			var z = Math.sqrt(10000 + movement * movement) + 100;
			var xs = movement / z * s;

			// this.debug.innerHTML += " move1: " + move;
			move += direction * (xs);
			// this.debug.innerHTML += " move2: " + move;
			
			xs = move + s;
			if ( xs < 0 ) { xs = 0; }
			if ( xs > 2*s ) { xs = 2*s - 1; }
			movement = (200 * s * ( xs -s ) / ( (2*s - xs) * xs )) / this.xstep;
			// this.debug.innerHTML += " movement1: " + movement;
			// this.debug.innerHTML += " xs: " + xs;

			// Maximum movement to either side
			if ( movement > this.focusedElememtsPerSide ) { movement = this.focusedElememtsPerSide; } 
			if ( movement < -this.focusedElememtsPerSide ) { movement = -this.focusedElememtsPerSide; }
			
			movement += this.scrollerStartDragOffset.current + (this.scrollerStartDragOffset.target - this.scrollerStartDragOffset.current);
			
			// this.debug.innerHTML += " movement2: " + movement;
			this.moveTo(movement, Math.round(movement));
			this.setSliderPosition(true);
			this.mouseDownByDrag = true;

			
			// // this.debug.innerHTML = movement + " " + this.current;
			
		} else {
			// this.debug.innerHTML += " dragging scroller";

			var deltaPercent = move * 100 / this.scrollbarwidth;
			var delta = Math.round(this.checkedImages.length / 100 * deltaPercent);

			if ( this.scrollerStartDragOffset !== false ) {
				var new_slider_pos = this.scrollerStartDragOffset - (direction * this.dragStartPosition) + (direction * posx);
				if ( new_slider_pos < 0 ) { new_slider_pos = 0; }
				if ( new_slider_pos > this.scrollbarwidth ) { new_slider_pos = this.scrollbarwidth ; }
				this.scroller.style.marginLeft = new_slider_pos - (this.scroller.offsetWidth / 2) + 'px';
			}

			if (this.scrollerDragOffset - delta != 0) {
				this.handle(delta - this.scrollerDragOffset);
				this.scrollerDragOffset = delta;
			}
		}

	};

	this.dragStart = function(e) {

		e = e||window.event;
		
		// this.debug.innerHTML = "Drag Start " + ((e.target) ? e.target : e.srcElement).id;
		if ( this.timeOutAction !== null ) { return; }
		
		this.dragStartPosition = document.all ? e.clientX : e.pageX;
		this.scrollerIsDragging = ((e.target) ? e.target : e.srcElement) == this.scroller;
		this.scrollerStartDragOffset = this.scrollerIsDragging ? this.scroller.offsetLeft : false;
		this.stopEvent(e);
	};
	
	this.dragStop = function(e) {
		
		e = e||window.event;
		// this.debug.innerHTML = "Drag Stop " + ((e.target) ? e.target : e.srcElement).id;

		if ( this.dragStartPosition === false ) { return; } 
		this.stopEvent(e);

		if ( this.scrollerIsDragging === false && typeof this.scrollerStartDragOffset == 'object' && isFinite(parseInt(this.scrollerStartDragOffset.target)) ) {
			// Snap to Element
			this.addMoveElementToQueue(Math.round(this.current));
		}

		this.dragStartPosition = false;
		this.scrollerStartDragOffset = false;
		this.scrollerIsDragging = false;
		this.scrollerDragOffset = 0;
		this.setSliderPosition();
		setTimeout( function() { _self.mouseDownByDrag = false; }, 100);
	};
	
	this.scrollerClick = function(e) {

		e = e ||window.event;
		this.stopEvent(e);
		
		if ( this.mouseDownByDrag ) { return; }
		if ( ((e.target) ? e.target : e.srcElement) != this.scroller.parentNode) { return; }
		// this.debug.innerHTML = "Scroller Click " + ((e.target) ? e.target : e.srcElement).id;
		
		this.mouseDownByDrag = true;
		
		this.dragStartPosition = findPosX(this.scroller) + this.scroller.offsetWidth/2;
		this.scrollerStartDragOffset = false;
		this.scrollerIsDragging = true;
		
		this.drag(e);
		this.dragStop(e);
		this.mouseDownByDrag = false;

		
	};
	
	this.scrollerSideDown = function(direction) {
		if ( this.scrollerDownIntervall !== false ) { return; }
		// this.debug.innerHTML = "Side Down";

		this.handle(direction);
		this.scrollerDownIntervall = window.setInterval( function() { _self.handle(direction); }, 500);
	};
	
	this.scrollerSideUp = function() {
		if ( this.scrollerDownIntervall === false ) { return; }
		// this.debug.innerHTML = "Side Up";

		window.clearInterval(this.scrollerDownIntervall);
		this.scrollerDownIntervall = false;
	};
	
	this.specialClick = function(e) {

		e=e||window.event;
		if ( this.mouseDownByDrag ) { return; }

		this.stopEvent(e);
		// this.debug.innerHTML = "Special Click";

		// If we have the popupviewer, lets do some action!
		if ( typeof popupviewer == 'undefined' ) {
			return;
		}
		
		if ( (whereToMove = this.getClickImage(e)) === false ) { return; }
		
		var viewer = new popupviewer();

		// Overwrite function
		viewer.skipToImage = function(itemNr) {

			var didMoveTo = _self.handle(itemNr);
			if ( didMoveTo === false ) { return; }
			
			var imageElement = _self.checkedImages[didMoveTo];

			imageElement.image.onclick = function(e) { _self.specialClick(e); };

			if (imageElement.image) {
				this.dispatchClick(imageElement.image);
			}
		};
		
		viewer.popupImageStack = this.checkedImages;
		var linkTo = this.checkedImages[whereToMove].imgData.linkto || this.checkedImages[whereToMove].imgData;
			
		viewer.init(e);
		if ( linkTo.isImage === true ) {
			viewer.displayContent(linkTo.src, true);
		} else {
			viewer.loadAndDisplayPage(linkTo.src, linkTo.width, linkTo.height, null, linkTo.params);
			viewer.page = this.checkedImages[whereToMove].id;
		}
	};
	
	this.elementClick = function(e) {
		e = e||window.event;

		if ( this.mouseDownByDrag ) { return; }
		if ( (whereToMove = this.getClickImage(e)) === false ) { return; }
		// this.debug.innerHTML = "Element Click " + ((e.target) ? e.target : e.srcElement).id;
		
		this.stopEvent(e);

		if ( this.timeOutAction ) {
			clearTimeout(this.timeOutAction);
			this.timeOutAction = null;
			this.whereToMoveQueue = new Array();
		}
		
		this.addMoveElementToQueue(whereToMove);
	};
	
	this.getClickImage = function(e) {
		e = e||window.event;
		
		var target = ((e.target) ? e.target : e.srcElement);
		// this.debug.innerHTML = "Click " + target.id;

		var whereToMove = 0;
		while ( target != this.checkedImages[whereToMove].image ) {
			whereToMove++;
		}
		
		if ( whereToMove >= this.checkedImages.length ) { return false; }
		return whereToMove;
	};
	
	this.checkForPopUp = function() {
		if ( document.location.href.indexOf('#') == 0 ) { return; }
		var extend = document.location.href.substr(document.location.href.indexOf('#')+1);
		if ( typeof extend == "undefined" || !$(extend) ) { return; }

		var e = {};
		e.target = $(extend);
		this.elementClick(e);
		this.specialClick(e);
	};
	
	this.globalEvent = function(e) {
		
		e = e||window.event;
		
		var delta = false;
		
		if (e.keyCode) {
			switch (e.keyCode) {
			/* Right arrow key */
			case 39:
				delta = 1;
				break;

			/* Left arrow key */
			case 37:
				delta = -1;
				break;
			}
		} else if (e.wheelDelta) {
			delta = -e.wheelDelta;
		} else if (e.detail) { // Mozilla Handling

			var target = ((e.target) ? e.target : e.srcElement);
			var nodes = this.root.getElementsByTagName(target.nodeName);
			for ( var elem in nodes ) {
				if ( nodes[elem] == target ) {
					delta = e.detail;
					break;
				}
			}
		}
		
		if ( delta ) {
			this.stopEvent(e);
			this.handle(delta  > 0 ? 1 : -1);
		}
	};
	
	this.init();
};


addInitEvent(function() {
		var imageflow = getElementsByClass('imageflow_wrapper', document, 'div');
		for ( var flow in imageflow ) {
			var imgF = new imageflow_plugin(imageflow[flow]);
		}
});