
var currentLayerAnimation = null;
var globalLayerAnimation = null;
var LayerPlayingTimeOut = null;
var layeranimation = function() {

	this.scrollTime = 500;
	this.waitTime = 10000;
	this.stepWidth = 20;
	this.nextItemIntverall = 0.7;
	this.zIndex = 1000;
	this.offsetWidth = 0;
	this.isPlaying = true;
	this.itemButtonClicked = false;
	
	this.isRunning = false;
	this.run = function(itemNrNew, layerNew) {

		// Set Current Item
		var itemNr = this.currentItem;
		if ( typeof itemNrNew == 'number' ) itemNr = itemNrNew;
		
		// Set Current Layer
		var layerNr = this.currentLayer;
		if ( typeof layerNew == 'number' ) layerNr = layerNew;
		
		// If it does not exist, return
		if ( !this.layer[layerNr] || !this.layer[layerNr].items[itemNr] ) { this.isRunning = false; return; }
		
		this.isRunning = true;

		// Get the Item
		var item =  this.layer[layerNr].items[itemNr];
		if ( itemNr == 0 && globalLayerAnimation.isPlaying ) {
			this.setActive(this.layerList.childNodes[layerNr], true, false);
		}
		
		// Calc Position + Timeout Step
		var currentLeft = parseInt(item.elem.style.left.substr(0, item.elem.style.left.length-2 ));
		var timeout = item.currentTime / (currentLeft * item.direction) * this.stepWidth;

		if ( ( currentLeft == this.offsetWidth && item.direction > 0 ) || ( currentLeft == -this.offsetWidth && item.direction < 0 ) ) {
			if ( /WebKit/i.test(navigator.userAgent) )
				this.layer[layerNr-1 < 0 ? this.layer.length-1 : layerNr-1].elem.style.opacity = 0;
			else
				this.resetLayer(layerNr -1 );
		}

		currentLeft -=  (this.stepWidth * item.direction);
		if ( ( currentLeft <= 0 && item.direction > 0 ) || ( currentLeft >= 0 && item.direction < 0 ) ) { currentLeft = 0; }
		
		// Set new Position and Timeout
		item.elem.style.left = currentLeft + 'px';
		if ( itemNr == 0 ) {
			this.layer[layerNr].elem.style.left = currentLeft + 'px';
		}

		// Start next Item in Layer after Intervall
		if ( item.currentTime <= (this.scrollTime * this.nextItemIntverall) ) {
			window.setTimeout('currentLayerAnimation.run(' + (itemNr +1) + ', ' + layerNr + ')', timeout);
			
			// Reset previous if next Layer comes
//			if ( this.layer.length > 1 && firstStep)
//				this.resetLayer(layerNr -1 );
			this.layer[layerNr].elem.style.zIndex = this.zIndex;
		}
		
		item.currentTime -= timeout;

		// If this is not the current layer, but an intervalled layer, return
		if ( itemNrNew || layerNew ) { return; }
		
		// scrolling done ?
		if ( itemNr == this.currentItem && (( currentLeft <= 0 && item.direction > 0 ) || ( currentLeft >= 0 && item.direction < 0 )) ) {
		
			if ( this.currentItem < this.layer[layerNr].items.length -1 ) {
			
				this.currentItem++;
			
			} else {
			
				if ( this.layer.length > 1 )
					this.resetLayer(layerNr -1 );
				this.layer[layerNr].elem.style.zIndex = this.zIndex;
					
				if ( layerNr < this.layer.length-1 ) {
					this.currentLayer++;				
				} else {
					this.currentLayer = 0;
				}
			
				this.currentItem = 0;
				timeout = this.waitTime;
				
				if ( ! globalLayerAnimation.isPlaying || this.layer.length == 1 ) {
					this.isRunning = false;
					return;
				}
			}
		}
		
		// next run routine;
		currentLayerAnimation = this;
		LayerPlayingTimeOut = window.setTimeout('currentLayerAnimation.run()', timeout);
	};
	
	this.resetLayer = function(layer, opacity) {
	
		if ( layer <0 ) { layer = this.layer.length-1; }
		if ( !this.layer[layer] ) { return; }
		if ( typeof opacity == 'undefined' ) opacity = 1;
		
//		alert("Reset Layer " + layer);
		
		for ( i=0; i<this.layer[layer].items.length; i++ ) {
		
			var item = this.layer[layer].items[i];
			
			item.elem.style.left = (item.direction < 0 ? -this.offsetWidth : this.offsetWidth) + 'px';
			if ( i == 0 ) {
				this.layer[layer].elem.style.left = (item.direction < 0 ? -this.offsetWidth : this.offsetWidth) + 'px';
				this.layer[layer].elem.style.opacity = opacity;
			}
			item.currentTime = this.scrollTime;
		}

		this.layer[layer].elem.style.zIndex = this.zIndex +100;
	};
	

	/* *****************************************************************************
	
		Build Structure
		
	***************************************************************************** */

	this.layerStruct = function() {
		this.items = new Array();
		this.elem = null;
	};
	
	this.itemStruct = function() {
		this.elem = null;
		this.direction = +1;
		this.currentTime = 0;
		this.next = null;
	};
	
	this.layerClick = function(elem) {
	
		this.Toggle = function(e) {
	
			if (!e) var e = window.event;
			this.elem = this;
			if (e.target) this.elem = e.target;
			else if (e.srcElement) this.elem = e.srcElement;
			if (this.elem.nodeType == 3) // defeat Safari bug
				this.elem = targ.parentNode;

			this.isPlayPause = this.elem.className.match(/play-pause/);
			this.active = !this.elem.className.match(/active/);
			
			this.playPauseToggle = function(e) {
				if ( this.active ) {
					// pause playing
					globalLayerAnimation.Pause();
					globalLayerAnimation.itemButtonClicked = true;
				} else {
					// start playing
					globalLayerAnimation.itemButtonClicked = false;
					globalLayerAnimation.Resume();
				}
			};
			
			this.layerToggle = function(e) {
				globalLayerAnimation.setActive( this.elem, this.active, this.isPlayPause);
				if ( this.active ) {

					if ( globalLayerAnimation.layer.length == 1 ) return;
					// stop all animation
					globalLayerAnimation.Pause();
					var resetLayer = globalLayerAnimation.currentLayer-1;
					if ( globalLayerAnimation.isRunning ) {
						window.clearTimeout(LayerPlayingTimeOut);
						globalLayerAnimation.resetLayer(globalLayerAnimation.currentLayer);
					}
					
//					globalLayerAnimation.layer[globalLayerAnimation.currentLayer].elem.style.zIndex = globalLayerAnimation.zIndex;
//					var resetLayer = globalLayerAnimation.currentLayer-1;
					if ( resetLayer < 0 ) resetLayer = globalLayerAnimation.layer.length -1;

					// reset Layer for position calculation
					globalLayerAnimation.currentItem = 0;
					globalLayerAnimation.currentLayer = 0;
					
					// get current Position
					var ListItem = this.elem.parentNode.firstChild;
					while ( ListItem != this.elem ) {
						globalLayerAnimation.currentLayer++;
						ListItem = ListItem.nextSibling;
					}
					
					// Set Playmode to pause
					globalLayerAnimation.setActive( this.elem.parentNode.lastChild, true, true );
					
					// Reset Layers manually to 0px
					globalLayerAnimation.layer[globalLayerAnimation.currentLayer].elem.style.left = '0px';
					for ( i=0; i<globalLayerAnimation.layer[globalLayerAnimation.currentLayer].items.length; i++ ) {
						globalLayerAnimation.layer[globalLayerAnimation.currentLayer].items[i].elem.style.left = '0px';
					}
					
					// Set zIndex and reset previous entry
					globalLayerAnimation.layer[globalLayerAnimation.currentLayer].elem.style.zIndex = globalLayerAnimation.zIndex;
					
//					alert('wait ' + globalLayerAnimation.currentLayer + ' ' + resetLayer + ' ' + globalLayerAnimation.layer[globalLayerAnimation.currentLayer].elem.style.zIndex);
					globalLayerAnimation.resetLayer(globalLayerAnimation.currentLayer-1);
					if ( resetLayer != globalLayerAnimation.currentLayer ) globalLayerAnimation.resetLayer(resetLayer);
					
					// prepare next Layer for animation
					if ( globalLayerAnimation.currentLayer < globalLayerAnimation.layer.length-1 ) {
						globalLayerAnimation.currentLayer++;				
					} else {
						globalLayerAnimation.currentLayer = 0;
					}
					
					// disable hover re-enable function
					globalLayerAnimation.itemButtonClicked = true;
					window.setTimeout(function() {
						// start playing
						globalLayerAnimation.Resume();
						
					}, 60000);
				} else {
				
					// start playing
					globalLayerAnimation.itemButtonClicked = false;
					globalLayerAnimation.Resume();
				}
			};
			
			return this.isPlayPause ? this.playPauseToggle() : this.layerToggle();
		};

		addEvent(elem, 'click', this.Toggle);
	};

	this.setActive = function(elem, active, isPlayPause) {
		
		// Reset "active" on each
		if ( !isPlayPause ) {
			var listItem = elem.parentNode.firstChild;
			while (listItem) {
				listItem.className = listItem.className.replace(/\s?active/g, "");
				listItem = listItem.nextSibling;
			}
		}
	
		// set "active" on current
		if ( active ) {
			elem.className += " active";
		} else if ( isPlayPause ) {
			elem.className = elem.className.replace(/\s?active/g, "");
		}
	};

	// Pause all animation if still playing
	this.Pause = function() {
		
		if ( ! globalLayerAnimation.isPlaying ) return;
		if ( globalLayerAnimation.itemButtonClicked ) return;
	
		globalLayerAnimation.isPlaying = false;
		if ( !globalLayerAnimation.isRunning ) window.clearTimeout(LayerPlayingTimeOut);
		globalLayerAnimation.setActive( $("layeranimation_layer").lastChild, true, true );
	};
	
	// resume animation if not playing
	this.Resume = function() {

		if ( globalLayerAnimation.isPlaying ) return;
		if ( globalLayerAnimation.itemButtonClicked ) return;
		if ( globalLayerAnimation.layer.length == 1 ) return;

		globalLayerAnimation.setActive( $("layeranimation_layer").lastChild, false, true );
		globalLayerAnimation.isPlaying = true;
		if ( !globalLayerAnimation.isRunning ) LayerPlayingTimeOut = window.setTimeout('currentLayerAnimation.run()', 2000);
	};

	this.root = $("layeranimation");
	this.layerList = $("layeranimation_layer");
	this.offsetWidth = 0;
	this.layer = new Array();
	this.currentLayer = 1;
	this.currentItem = 0;

	this.init = function() {
		
		if ( !this.root || !this.layerList ) {
			return;
		}
		
		this.offsetWidth = this.root.offsetWidth;
		this.root.className += "scripting";

		this.layer = new Array();
		var layer = this.root.firstChild;
		
		while ( layer ) {

			if ( layer.nodeType == 1 && layer.className.indexOf("layer") >= 0 ) {


				var innerLayer = new this.layerStruct();
				innerLayer.elem = layer;
				innerLayer.elem.style.zIndex = this.zIndex +100;
				innerLayer.elem.style.display = "block";
				innerLayer.elem.style.webkitTransitionDuration = (this.scrollTime / 1000 * 2) + "s";

				innerLayer.elem.style.opacity = 1;

				if ( this.layer.length <= 1 && layer.className.indexOf("fixed") >= 0 ) {
					innerLayer.elem.style.zIndex = 100;
				} else {
					
					addEvent(innerLayer.elem, 'mouseover', this.Pause);
					addEvent(innerLayer.elem, 'mouseout', this.Resume);
					this.layer.push(innerLayer);
					
					var layerListItem = document.createElement('li');
					layerListItem.appendChild(document.createTextNode(this.layer.length));
					layerListItem.title = 'skip to layer ' + this.layer.length;
					if ( this.layer.length <= 1 ) {
						layerListItem.className += " active";
					}
					
					new this.layerClick(layerListItem);
					
					this.layerList.appendChild(layerListItem);
				}
				
				var item = layer.firstChild;
				while ( item ) {
				
					if ( item.nodeType == 1 && item.className.indexOf("item") >= 0 ) {
				
						var innerItem = new this.itemStruct();
						innerItem.direction = item.className.indexOf("right") >= 0 ? -1 : 1;
						innerItem.currentTime = this.scrollTime;
						innerItem.elem = item;
						
						
						if ( this.layer.length <= 1 || layer.className.indexOf("fixed") >= 0 ) {
							innerItem.elem.style.left = '0px';
						} else { 
							innerItem.elem.style.left = (innerItem.direction < 0 ? -this.offsetWidth : this.offsetWidth) + 'px';
							if ( innerLayer.items.length < 1 && item.className.indexOf("first") < 0 )
								innerLayer.elem.style.left = (innerItem.direction < 0 ? -this.offsetWidth : this.offsetWidth) + 'px';
						}
						
						if ( innerLayer.items.length < 1 && item.className.indexOf("first") < 0 ) {
							item.className += " first";
						}
												
						innerLayer.items.push(innerItem);
					}
					
					item = item.nextSibling;
				}
			}
			
			layer = layer.nextSibling;
		}
	
		var layerListItem = document.createElement('li');
		layerListItem.className = "play-pause";
		layerListItem.title = 'pause animation';
		this.layerList.appendChild(layerListItem);
		new this.layerClick(layerListItem, this);
		
		currentLayerAnimation = this;
		LayerPlayingTimeOut = window.setTimeout("currentLayerAnimation.run();", this.waitTime);
	};
};


addInitEvent(function() { (globalLayerAnimation = new layeranimation()).init(); });